import { createSlice, PayloadAction } from "@reduxjs/toolkit";
import type { RootState } from "./";

interface CommonState {
  roomCode: string;
  shouldStartClueClock: boolean;
}

const initialState: CommonState = {
  roomCode: "",
  shouldStartClueClock: false,
};

export const commonSlice = createSlice({
  name: "common",
  initialState,
  reducers: {
    setRoomCode: (state, { payload }: PayloadAction<string>) => {
      state.roomCode = payload;
    },
    setShouldStartClueClock: (state, { payload }: PayloadAction<boolean>) => {
      state.shouldStartClueClock = payload;
    },
  },
});

export const { setRoomCode, setShouldStartClueClock } = commonSlice.actions;
export const selectRoomCode = (state: RootState) => state.common.roomCode;
export const selectShouldStartClueClock = (state: RootState) =>
  state.common.shouldStartClueClock;

export default commonSlice.reducer;
